/*
 * nlsop headers
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#ifndef NLSOP_H
#define NLSOP_H

#ifndef _U32
#define _U32
typedef unsigned int u32;
#endif

typedef struct __info
{
 int cc,steps,range,diff_rate,cpi,s_rate,save_rate;
 double s,b,c,dr_ac;
} info;

#define AMORPH 1

#define _X 64
#define _Y 64
#define _Z 233

#define STEPS 158671500
#define RANGE 5
#define REFRESH 100000
#define RESAVE 20000000

#define CC 0

#define DR_AC .05
#define DIFF_RATE 1000000

#define S_D .0001
#define B_D .01
#define C_D .001

#define MAX_CHARS 128
#define MAX_TXT 40
#define MAX_ARGV 27

#define IMP_PROFILE "imp-profile.txt"
#define NEL_PROFILE "nel-profile.txt"

#define CELL_LENGTH 3 /* nm */

#define CPI 100

#define S_RATE ((2*3*STEPS)/100)
#define SI_PER_VOLUME (168*8)

#define A_START 0.23
#define AC_START 0.89
#define A_END 0.84

#define FFT_HEIGHT 64

#endif /* NLSOP_H */
